api/urls.py
from django.urls import path
from . import views

app_name = 'api'

urlpatterns = [
    path('sessions/<slug:session_key>/', views.Sessions.as_view(), name='api-sessions'),
    path('surveys/<int:survey_id>/', views.Surveys.as_view(), name='api-surveys'),
]

framework/urls.py
from django.contrib import admin
from django.urls import path, include
from accounts import views as account_views
from django.contrib.auth import views as auth_views
from django.conf.urls.i18n import i18n_patterns
from . import settings
from django.conf.urls.static import static

urlpatterns = [
    path('i18n/', include('django.conf.urls.i18n')),
    path('admin/', admin.site.urls, name='admin'),
    # path('register/', account_views.register, name='register'),
    path('login/', auth_views.LoginView.as_view(template_name='accounts/login.html'), name='login'),
    path('logout/', auth_views.LogoutView.as_view(template_name='accounts/logout.html'), name='logout'),
    path('api/', include('api.urls', namespace='api')),

    # path('surveys/', include('surveys.urls', namespace='surveys')),
    # Installed apps
    path('tinymce/', include('tinymce.urls')),

]

urlpatterns += i18n_patterns(
    path('surveys/', include('surveys.urls', namespace='surveys')),
    path('', include('home.urls', namespace='home')),
)

urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

home/urls.py
from django.urls import path
from . import views
from django.contrib.auth.decorators import login_required


app_name = 'home'

urlpatterns = [
    path('', views.home, name='index'),
    path('post/new/', login_required(views.PostCreateView.as_view()), name='new-post'),
    path('post/<int:pk>/update/', login_required(views.PostUpdateView.as_view()), name="update-post")
]

surveys/urls.py
from django.urls import path
from surveys.views import SurveysView, SurveyUptateView
from . import views
from django.contrib.auth.decorators import login_required

app_name = 'surveys'

urlpatterns = [
    path('', SurveysView.as_view(), name='surveys'),
    path('<int:pk>/', views.survey_detail, name='survey'),
    path('new/', login_required(views.create_survey), name='create-survey'),
    path('<int:pk>/delete/', login_required(views.delete_survey), name='delete-survey'),
    path('<int:pk>/edit/', login_required(SurveyUptateView.as_view()), name='edit-survey'),
    path('<int:pk>/delete-sessions/', login_required(views.delete_sessions), name='delete-sessions'),

    path('<int:survey_id>/introduction/', views.introduction, name='introduction'),
    path('<int:survey_id>/load/', views.load_set, name='load-survey'),
    path('<int:survey_id>/<slug:session_key>/', views.session_detail, name='session'),
    path('<int:survey_id>/<slug:session_key>/instructions/', views.instructions, name='instructions'),

    path('<int:survey_id>/<slug:session_key>/survey/ready/', views.survey_ready, name='survey-ready'),
    path('<int:survey_id>/<slug:session_key>/block/ready/', views.block_ready, name='block-ready'),

    path('<int:survey_id>/<slug:session_key>/trial/', views.trial, name='trial'),
    path('<int:survey_id>/<slug:session_key>/trial/save/<int:trial_id>/', views.save_trial, name='save-trial'),

    path('<int:survey_id>/<slug:session_key>/training/', views.training, name='training'),
    path('<int:survey_id>/<slug:session_key>/save-training/', views.save_training, name='save-training'),

    path('<int:survey_id>/<slug:session_key>/end/', views.end, name='end'),

]

home/models.py
from django.db import models
from tinymce.models import HTMLField
from django.urls import reverse
from surveys.models import Survey
# Create your models here.
class Post(models.Model):
    POST_TYPES = [
        ('HOMEPAGE', 'Homepage'),
        ('POST', 'Post or Blogpost'),
        ('PAGE', 'Page')
    ]
    title = models.CharField(max_length=70)
    content = HTMLField()
    created = models.DateTimeField(auto_now=True)
    type = models.CharField(max_length=70, choices=POST_TYPES, default='PAGE')

    def __str__(self):
        return str(self.title)

    def get_absolute_url(self):
        return reverse('home:index')

class Setting(models.Model):
    name = models.CharField(max_length=256, verbose_name="Settings name")
    value = models.CharField(max_length=256, verbose_name="Settings value")

    def __str__(self):
        return str(self.name)

home/forms.py
from django import forms

home/views.py
from django.shortcuts import render, redirect, get_object_or_404
from . import views
from .models import Post, Setting
from django.contrib import messages
from django.contrib.auth.decorators import login_required
from django.views import generic
from django.urls import reverse
from django.contrib.messages.views import SuccessMessageMixin
# Create your views here.

# Renders the homepage
def home(request):
    homepage = get_object_or_404(Post, type='HOMEPAGE')
    active_survey = 1
    try:
        active_survey = get_object_or_404(Setting, name="Active Survey")
        active_survey = active_survey.value
    except:
        print("Active Survey not set!")
    context = {
        'homepage': homepage,
        'active_survey': active_survey
    }
    return render(request, 'home/index.html', context)

# Generic view for creating a post
class PostCreateView(SuccessMessageMixin, generic.CreateView):
    model = Post
    fields = [
        'title',
        'content',
        'type'
    ]
    success_message = "Post was created successfully"

# Generic view for update a post
class PostUpdateView(SuccessMessageMixin, generic.UpdateView):
    model = Post
    fields = [
        'title',
        'content',
        'type'
    ]

    success_message = "Post was updated successfully"

home/templates/home/edit-post.html
{% extends 'base.html' %}
{% block body %}
{% load static %}
{% load widget_tweaks %}
<div class="uk-container uk-margin-top">
  <form class="uk-form-stacked" method="post">
  {% csrf_token %}
    <fieldset class="uk-fieldset">
      <legend class="uk-legend">Edit post</legend>
      <div class="uk-margin">
        <label class="uk-form-label" for="form-stacked-text">Text</label>
        <div class="uk-form-controls">
            {{ form.title|add_class:"uk-input"|attr:"placeholder:Post Title" }}
        </div>
      </div>
      <div class="uk-margin">
        <label class="uk-form-label" for="form-stacked-text">Content:</label>
        <div class="uk-form-controls">
            {{ form.content }}
        </div>
      </div>
      <div class="uk-margin">
        <label class="uk-form-label" for="form-stacked-text">Content:</label>
        <div class="uk-form-controls">
            {{ form.type|add_class:"uk-select" }}
        </div>
      </div>
      <p class="uk-margin">
        <button class="uk-button uk-button-secondary" type="submit" name="button">Save</button>
      </p>
  </form>
</div>
{% endblock %}

home/templates/home/header.html
<nav id="nav" class="uk-navbar uk-navbar-container">
    <div class="uk-navbar-left">
        {% if user.is_authenticated %}
        <a class="uk-navbar-toggle" uk-navbar-toggle-icon uk-toggle="target: #offcanvas-usage" href="#"></a>
        {% endif %}
        <a class="uk-navbar-item uk-logo" href="{% url 'home:index' %}">Decision Task Framework</a>
    </div>
</nav>
<div id="offcanvas-usage" uk-offcanvas="overlay: true" uk-offcanvas>
    <div class="uk-offcanvas-bar">
      <button class="uk-offcanvas-close" type="button" uk-close></button>
        <ul class="uk-nav uk-nav-default">
          <li class="uk-nav-header">Decision Task Framework</li>
            <li class="uk-nav-divider"></li>
            <li><a href="{% url 'home:index' %}">Home</a></li>
            <li><a href="{% url 'surveys:surveys' %}">Surveys</a></li>
            <li class="uk-nav-header">User Management</li>
            <li class="uk-nav-divider"></li>
            {% if user.is_authenticated %}
            <li><a class="uk-disabled"href="#"><span class="uk-icon uk-margin-small-right" uk-icon="icon: user"></span><span class="uk-label">{{user}}</span></a></li>
            <li><a href="{% url 'admin:index' %}">Django Admin</a></li>
            <li><a href="{% url 'logout' %}">Logout</a></li>
            {% else %}
            <li><a href="{% url 'login' %}">Login</a></li>
            {% endif %}
        </ul>
    </div>
</div>

home/templates/home/index.html
{% extends 'base.html' %}
{% block body %}
{% load static %}
{% load i18n %}
{% get_current_language as LANGUAGE_CODE %}
<form class="uid uk-position-top-right uk-form-width-medium" action="{% url 'set_language' %}" method="post">
  {% csrf_token %}
  <input type="hidden" name="next" value="{% url 'home:index' %}">
  <div class="uk-margin">
    <div uk-form-custom="target: > * > span:first-child">
      <select name="language" onchange="this.form.submit()">
        <option value="en" {% if LANGUAGE_CODE == 'en'%} selected {% endif %}>English</option>
        <option value="de" {% if LANGUAGE_CODE == 'de'%} selected {% endif %}>Deutsch</option>
      </select>
      <button class="uk-button uk-button-primary" type="button" tabindex="-1">
        <span></span>
        <span uk-icon="icon: chevron-down"></span>
      </button>
    </div>
  </div>
</form>
<div class="uk-height-medium uk-flex uk-flex-center uk-flex-middle uk-background-cover" data-src="{% static 'home/img/robots-humans.png'%}" uk-img>
  <p class="uk-margin">
    <a class="uk-button uk-button-secondary uk-button-large uk-hidden" href="{% url 'surveys:introduction' active_survey %}">{% trans "Play" %}</a>
  </p>
</div>
<div class="uk-container uk-margin-top">
  <h1 class="uk-heading-small">{{homepage.title}}</h1>
  {% if user.is_authenticated %}
  <ul class="uk-iconnav">
    <li><a href="{% url 'home:update-post' homepage.id %}" uk-tooltip="Edit homepage" uk-icon="icon: file-edit"></a></li>
  </ul>
  {% endif %}
  {{homepage.content|safe}}
  <a class="uk-button uk-button-primary uk-margin-large-bottom" href="{% url 'surveys:introduction' active_survey %}">{% trans "Start experiment" %}</a>
</div>
{% endblock %}

home/templates/home/post_form.html
{% extends 'base.html' %}
{% block body %}
{% load static %}
{% load widget_tweaks %}
<div class="uk-container uk-margin-top">
  <form class="uk-form-stacked" method="post">
  {% csrf_token %}
    <fieldset class="uk-fieldset">
      <legend class="uk-legend">Create new post</legend>
      <div class="uk-margin">
        <label class="uk-form-label" for="form-stacked-text">Text</label>
        <div class="uk-form-controls">
            {{ form.title|add_class:"uk-input"|attr:"placeholder:Post Title" }}
        </div>
      </div>
      <script>tinymce.init({selector:'textarea'});</script>
      <div class="uk-margin">
        <label class="uk-form-label" for="form-stacked-text">Content:</label>
        <div class="uk-form-controls">
            {{ form.content }}
        </div>
      </div>
      <div class="uk-margin">
        <label class="uk-form-label" for="form-stacked-text">Content:</label>
        <div class="uk-form-controls">
            {{ form.type|add_class:"uk-select" }}
        </div>
      </div>
      <p class="uk-margin">
        <button class="uk-button uk-button-secondary" type="submit" name="button">Save</button>
      </p>
  </form>
</div>
{% endblock %}

home/templates/home/scripts.html
<!-- UIkit JS -->
{% load static %}
<script src="{% static 'home/js/uikit.min.js'%}"></script>
<script src="{% static 'home/js/uikit-icons.min.js'%}"></script>